/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton interface for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ACT_ACCEPT = 258,
     ACT_REJECT = 259,
     ACT_TEMPFAIL = 260,
     ACT_CONTINUE = 261,
     ACT_DISCARD = 262,
     ADD = 263,
     REPLACE = 264,
     DELETE = 265,
     PROG = 266,
     KW_BEGIN = 267,
     KW_END = 268,
     IF = 269,
     FI = 270,
     ELSE = 271,
     ELIF = 272,
     ON = 273,
     HOST = 274,
     FROM = 275,
     AS = 276,
     DO = 277,
     DONE = 278,
     POLL = 279,
     MATCHES = 280,
     FNMATCHES = 281,
     MXMATCHES = 282,
     MXFNMATCHES = 283,
     WHEN = 284,
     PASS = 285,
     SET = 286,
     CATCH = 287,
     THROW = 288,
     KW_ECHO = 289,
     RETURNS = 290,
     RETURN = 291,
     FUNC = 292,
     SWITCH = 293,
     CASE = 294,
     DEFAULT = 295,
     CONST = 296,
     FOR = 297,
     LOOP = 298,
     WHILE = 299,
     BREAK = 300,
     NEXT = 301,
     ARGCOUNT = 302,
     ALIAS = 303,
     DOTS = 304,
     ARGX = 305,
     VAPTR = 306,
     STRING = 307,
     CODE = 308,
     XCODE = 309,
     SYMBOL = 310,
     IDENTIFIER = 311,
     ARG = 312,
     NUMBER = 313,
     BACKREF = 314,
     BUILTIN = 315,
     BUILTIN_PROC = 316,
     BUILTIN_P = 317,
     OR = 318,
     AND = 319,
     EQ = 320,
     NE = 321,
     LT = 322,
     LE = 323,
     GT = 324,
     GE = 325,
     NOT = 326,
     LOGAND = 327,
     LOGOR = 328,
     LOGXOR = 329,
     LOGNOT = 330,
     FUNCTION = 331,
     FUNCTION_PROC = 332,
     FUNCTION_P = 333,
     TYPE = 334,
     VARIABLE = 335,
     BOGUS = 336,
     CONCAT = 337,
     UMINUS = 338
   };
#endif
/* Tokens.  */
#define ACT_ACCEPT 258
#define ACT_REJECT 259
#define ACT_TEMPFAIL 260
#define ACT_CONTINUE 261
#define ACT_DISCARD 262
#define ADD 263
#define REPLACE 264
#define DELETE 265
#define PROG 266
#define KW_BEGIN 267
#define KW_END 268
#define IF 269
#define FI 270
#define ELSE 271
#define ELIF 272
#define ON 273
#define HOST 274
#define FROM 275
#define AS 276
#define DO 277
#define DONE 278
#define POLL 279
#define MATCHES 280
#define FNMATCHES 281
#define MXMATCHES 282
#define MXFNMATCHES 283
#define WHEN 284
#define PASS 285
#define SET 286
#define CATCH 287
#define THROW 288
#define KW_ECHO 289
#define RETURNS 290
#define RETURN 291
#define FUNC 292
#define SWITCH 293
#define CASE 294
#define DEFAULT 295
#define CONST 296
#define FOR 297
#define LOOP 298
#define WHILE 299
#define BREAK 300
#define NEXT 301
#define ARGCOUNT 302
#define ALIAS 303
#define DOTS 304
#define ARGX 305
#define VAPTR 306
#define STRING 307
#define CODE 308
#define XCODE 309
#define SYMBOL 310
#define IDENTIFIER 311
#define ARG 312
#define NUMBER 313
#define BACKREF 314
#define BUILTIN 315
#define BUILTIN_PROC 316
#define BUILTIN_P 317
#define OR 318
#define AND 319
#define EQ 320
#define NE 321
#define LT 322
#define LE 323
#define GT 324
#define GE 325
#define NOT 326
#define LOGAND 327
#define LOGOR 328
#define LOGXOR 329
#define LOGNOT 330
#define FUNCTION 331
#define FUNCTION_PROC 332
#define FUNCTION_P 333
#define TYPE 334
#define VARIABLE 335
#define BOGUS 336
#define CONCAT 337
#define UMINUS 338




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 303 "gram.y"
{
	struct literal *literal;
	struct stmtlist stmtlist;
	NODE *node;
	struct return_node ret;
	struct poll_data poll;
	struct locus locus;
	struct pollarg {
		int kw;
		NODE *expr;
	} pollarg;
	struct arglist {
		NODE *head;
		NODE *tail;
		size_t count;
	} arglist;
	long number;
	const struct builtin *builtin;
	struct variable *var;
	enum smtp_state state;
	struct {
		struct locus locus;
		int qualifier;
	} matchtype;
	data_type_t type;
	struct parmtype *parm;
	struct parmlist {
		struct parmtype *head, *tail;
		size_t count;
		size_t optcount;
		int varargs;
	} parmlist;
	enum lexical_context tie_in;
	struct function *function;
	struct {
		struct valist *head, *tail;
	} valist_list;
	struct valist *valist;
	struct value value;
	struct {
		struct case_stmt *head, *tail;
	} case_list ;
	struct case_stmt *case_stmt;
	struct loop_node loop;
	struct {
		struct locus locus;
		int code;
	} progspecial;
	mu_list_t list;
}
/* Line 1489 of yacc.c.  */
#line 266 "gram.h"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

extern YYSTYPE yylval;

